# I needed to add two lines to openssl.cnf but the rest was fine. 
#[ san ]
#subjectAltName=${ENV::SAN}

# Step 1: generate the KEY/CSR
mkdir le_"$(date +%Y-%m-%d)"
pushd "$_" || exit 1
if [ "$(find .)" != "." ]; then
	echo "Remove the files from this directory: le_"$(date +%Y-%m-%d)" and run again."
	popd
	exit 1
fi
export CSR_PATH=cell-game.com_"$(date +%Y-%m-%d)".csr
export KEY_PATH=cell-game.com_"$(date +%Y-%m-%d)".key
export OPENSSL_CNF=../openssl.cnf
/usr/local/bin/generate-csr.sh cell-game.com www.cell-game.com || exit 2

# Step 2: Sign CSR

/usr/local/bin/sign_csr.py --registered --file-based -e 'jvoss@altsci.com' -p ../user.pub "$CSR_PATH" || exit 3

#cat >~/altsci/cell/.well-known/acme-challenge/6PFRGvqJBkEFIokkS9x1X-GIeTmbVXUPusqY1ZXptvM
#6PFRGvqJBkEFIokkS9x1X-GIeTmbVXUPusqY1ZXptvM.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk
#cat >~/altsci/cell/.well-known/acme-challenge/t-S38Kh9oFyv9lvdASgQYIp_aYL_CDFGTvbHhfNXIF8
#t-S38Kh9oFyv9lvdASgQYIp_aYL_CDFGTvbHhfNXIF8.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk

cat >cell-game.com_2015-12-04.crt
sudo mv -i "$KEY_PATH" /etc/ssl/private/
sudo cp -i "${CSR_PATH%.csr}.crt" /etc/ssl/acerts/
sudo ln -sf "$KEY_PATH" /etc/ssl/private/cell-game.com.key
sudo ln -sf "${CSR_PATH%.csr}.crt" /etc/ssl/acerts/cell-game.com.crt
rm -r ~/altsci/cell/.well-known/

# Step 7: Cleanup and Go back to the parent directory
if ![ -e ../cell-game.com_"$(date +%Y-%m-%d)".tgz ]; then
	tar cf ../cell-game.com_"$(date +%Y-%m-%d)".tgz *
	rm "$CSR_PATH" "${CSR_PATH%.csr}.crt"
	if [ "$(find .)" != "." ]; then
		echo "Files left by one of the programs woops."
		ls -la
	fi
else
	echo "Tar file exists cell-game.com_"$(date +%Y-%m-%d)".tgz, not going to overwrite it. Cleanup yourself."
fi
popd
