# I needed to add two lines to openssl.cnf but the rest was fine. 
#[ san ]
#subjectAltName=${ENV::SAN}

# Step 1: generate the KEY/CSR
mkdir le_"$(date +%Y-%m-%d)"
pushd "$_" || exit 1
if [ "$(find .)" != "." ]; then
	echo "Remove the files from this directory: le_"$(date +%Y-%m-%d)" and run again."
	popd
	exit 1
fi
export CSR_PATH=mail.altsci.com_"$(date +%Y-%m-%d)".csr
export KEY_PATH=mail.altsci.com_"$(date +%Y-%m-%d)".key
export OPENSSL_CNF=../openssl.cnf
/usr/local/bin/generate-csr.sh mail.altsci.com suzy.altsci.com || exit 2

# Step 2: Sign CSR

# Not using --file-based because suzy has been down for months.
/usr/local/bin/sign_csr.py --registered -e 'jvoss@altsci.com' -p ../user.pub "$CSR_PATH" || exit 3

# scp -P221 *.json altsci.com:letsencrypt/le_2015-12-04/
# sign
# scp -P221 altsci.com:letsencrypt/le_2015-12-04/*.sig .
# scp -P221 challenge*.json altsci.com:letsencrypt/le_2015-12-04/
# sign
# scp -P221 altsci.com:letsencrypt/le_2015-12-04/challenge*.sig .
# 

cat >"${CSR_PATH%.csr}.crt"
# sudo mv -i "$KEY_PATH" /etc/ssl/postfix/
# sudo cp -i "${CSR_PATH%.csr}.crt" /etc/ssl/postfix/
# sudo cp -i "${CSR_PATH%.csr}.crt" /etc/ssl/apache2/
# sudo ln -sf "$KEY_PATH" /etc/ssl/private/mail.altsci.com.key
# sudo ln -sf "${CSR_PATH%.csr}.crt" /etc/ssl/apache2/mail.altsci.com.crt
# cat ~/recent/pfm/projects/letsencrypt/lets-encrypt-x1-cross-signed.pem |sudo tee -a /etc/ssl/postfix/"${CSR_PATH%.csr}.crt"

# Step 7: Cleanup and Go back to the parent directory
if ![ -e ../mail.altsci.com_"$(date +%Y-%m-%d)".tgz ]; then
	tar cf ../mail.altsci.com_"$(date +%Y-%m-%d)".tgz *
	rm "$CSR_PATH" "${CSR_PATH%.csr}.crt"
	if [ "$(find .)" != "." ]; then
		echo "Files left by one of the programs woops."
		ls -la
	fi
else
	echo "Tar file exists mail.altsci.com_"$(date +%Y-%m-%d)".tgz, not going to overwrite it. Cleanup yourself."
fi
popd
