# I needed to add two lines to openssl.cnf but the rest was fine. 
#[ san ]
#subjectAltName=${ENV::SAN}

# Step 1: generate the KEY/CSR
mkdir le_"$(date +%Y-%m-%d)"
pushd "$_" || exit 1
if [ "$(find .)" != "." ]; then
	echo "Remove the files from this directory: le_"$(date +%Y-%m-%d)" and run again."
	popd
	exit 1
fi
export CSR_PATH=sono.us_"$(date +%Y-%m-%d)".csr
export KEY_PATH=sono.us_"$(date +%Y-%m-%d)".key
export OPENSSL_CNF=../openssl.cnf
/usr/local/bin/generate-csr.sh sono.us www.sono.us || exit 2

# Step 2: Sign CSR

/usr/local/bin/sign_csr.py --registered --file-based -e 'jvoss@altsci.com' -p ../user.pub "$CSR_PATH" || exit 3

# The rest has to be done at the command of the script, so...
exit 1
# Step 3: Sign domain and cert with user key.
openssl dgst -sha256 -sign ../user.key -out domain_iAeMyj.sig domain_vE2zKX.json
openssl dgst -sha256 -sign ../user.key -out domain_e6dMMs.sig domain_pZuSfI.json
openssl dgst -sha256 -sign ../user.key -out cert_lq8U0d.sig cert_sg_noO.json

# Step 4: Sign challenge with user key
openssl dgst -sha256 -sign ../user.key -out challenge_zPzZAb.sig challenge_iSYWZf.json
openssl dgst -sha256 -sign ../user.key -out challenge_WabMS7.sig challenge_F36XCq.json

# Step 5: Proof of ownership
#mkdir -p /home/www/sono.us/.well-known/acme-challenge/
#cat >/home/www/sono.us/.well-known/acme-challenge/F7V2H0SQUTnPXaGDB-78f4m4sCBlwqyAydSLvLVjY-g
#F7V2H0SQUTnPXaGDB-78f4m4sCBlwqyAydSLvLVjY-g.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk
#cat >/home/www/sono.us/.well-known/acme-challenge/nfHcWhXtnu5gAAn5q1eMLqAs2UzWcZtISKynqAta7VM
#nfHcWhXtnu5gAAn5q1eMLqAs2UzWcZtISKynqAta7VM.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk

# Step 6: Save output certificate
cat >"${CSR_PATH%.csr}.crt"

# Step 7: Copy cert and key.
sudo mv -i "$KEY_PATH" /etc/ssl/private/
sudo chown root:root /etc/ssl/private/"$KEY_PATH"
sudo cp -i "${CSR_PATH%.csr}.crt" /etc/ssl/acerts/

# Step 7: Cleanup and Go back to the parent directory
if ![ -e ../sono.us_"$(date +%Y-%m-%d)".tgz ]; then
	tar cf ../sono.us_"$(date +%Y-%m-%d)".tgz *
	rm "$CSR_PATH" "${CSR_PATH%.csr}.crt"
	if [ "$(find .)" != "." ]; then
		echo "Files left by one of the programs woops."
		ls -la
	fi
else
	echo "Tar file exists sono.us_"$(date +%Y-%m-%d)".tgz, not going to overwrite it. Cleanup yourself."
fi
popd

# Temporary fix:
sudo mv -i /etc/ssl/private/sono.us.key /etc/ssl/private/sono.us_2015-10-27.key
sudo ln -s sono.us_2015-12-04.key /etc/ssl/private/sono.us.key
# permanent fix:
sudo rm /etc/ssl/private/sono.us.key
sudo ln -s "$KEY_PATH" /etc/ssl/private/sono.us.key
