# I needed to add two lines to openssl.cnf but the rest was fine. 
#[ san ]
#subjectAltName=${ENV::SAN}

# Step 1: generate the KEY/CSR
mkdir le_"$(date +%Y-%m-%d)"
pushd "$_" || exit 1
if [ "$(find .)" != "." ]; then
	echo "Remove the files from this directory: le_"$(date +%Y-%m-%d)" and run again."
	popd
	exit 1
fi
export CSR_PATH=small-wide-world.com_"$(date +%Y-%m-%d)".csr
export KEY_PATH=small-wide-world.com_"$(date +%Y-%m-%d)".key
export OPENSSL_CNF=../openssl.cnf
/usr/local/bin/generate-csr.sh small-wide-world.com www.small-wide-world.com || exit 2

# Step 2: Sign CSR

/usr/local/bin/sign_csr.py --registered --file-based -e 'jvoss@altsci.com' -p ../user.pub "$CSR_PATH" || exit 3

# mkdir -p /home/www/altsci/concepts/smallwideworld/.well-known/acme-challenge
#cat >/home/www/altsci/concepts/smallwideworld/.well-known/acme-challenge/6PFRGvqJBkEFIokkS9x1X-GIeTmbVXUPusqY1ZXptvM
#6PFRGvqJBkEFIokkS9x1X-GIeTmbVXUPusqY1ZXptvM.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk
#cat >/home/www/altsci/concepts/smallwideworld/.well-known/acme-challenge/t-S38Kh9oFyv9lvdASgQYIp_aYL_CDFGTvbHhfNXIF8
#t-S38Kh9oFyv9lvdASgQYIp_aYL_CDFGTvbHhfNXIF8.duIKaKyCkI0IA1Z9KNweXU2uKde7Gq4FU2Q26BB4FYk

cat >"${CSR_PATH%.csr}.crt"
sudo mv -i "$KEY_PATH" /etc/ssl/private/
sudo cp -i "${CSR_PATH%.csr}.crt" /etc/ssl/acerts/
sudo ln -sf "$KEY_PATH" /etc/ssl/private/small-wide-world.com.key
sudo ln -sf "${CSR_PATH%.csr}.crt" /etc/ssl/acerts/small-wide-world.com.crt
rm -r /home/www/altsci/concepts/smallwideworld/.well-known

# Step 7: Cleanup and Go back to the parent directory
if ![ -e ../small-wide-world.com_"$(date +%Y-%m-%d)".tgz ]; then
	tar cf ../small-wide-world.com_"$(date +%Y-%m-%d)".tgz *
	rm "$CSR_PATH" "${CSR_PATH%.csr}.crt"
	if [ "$(find .)" != "." ]; then
		echo "Files left by one of the programs woops."
		ls -la
	fi
else
	echo "Tar file exists small-wide-world.com_"$(date +%Y-%m-%d)".tgz, not going to overwrite it. Cleanup yourself."
fi
popd
sudo /etc/init.d/apache2 reload
sudo -k
